// Code generated by go-swagger; DO NOT EDIT.

package client

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"
	httptransport "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/openclarity/kubeclarity/shared/pkg/scanner/dependency_track/api/client/client/bom"
	"github.com/openclarity/kubeclarity/shared/pkg/scanner/dependency_track/api/client/client/component"
	"github.com/openclarity/kubeclarity/shared/pkg/scanner/dependency_track/api/client/client/finding"
	"github.com/openclarity/kubeclarity/shared/pkg/scanner/dependency_track/api/client/client/project"
	"github.com/openclarity/kubeclarity/shared/pkg/scanner/dependency_track/api/client/client/vulnerability"
)

// Default dependency track API HTTP client.
var Default = NewHTTPClient(nil)

const (
	// DefaultHost is the default Host
	// found in Meta (info) section of spec file
	DefaultHost string = "dependency-track-apiserver"
	// DefaultBasePath is the default BasePath
	// found in Meta (info) section of spec file
	DefaultBasePath string = "/api"
)

// DefaultSchemes are the default schemes found in Meta (info) section of spec file
var DefaultSchemes = []string{"http", "https"}

// NewHTTPClient creates a new dependency track API HTTP client.
func NewHTTPClient(formats strfmt.Registry) *DependencyTrackAPI {
	return NewHTTPClientWithConfig(formats, nil)
}

// NewHTTPClientWithConfig creates a new dependency track API HTTP client,
// using a customizable transport config.
func NewHTTPClientWithConfig(formats strfmt.Registry, cfg *TransportConfig) *DependencyTrackAPI {
	// ensure nullable parameters have default
	if cfg == nil {
		cfg = DefaultTransportConfig()
	}

	// create transport and client
	transport := httptransport.New(cfg.Host, cfg.BasePath, cfg.Schemes)
	return New(transport, formats)
}

// New creates a new dependency track API client
func New(transport runtime.ClientTransport, formats strfmt.Registry) *DependencyTrackAPI {
	// ensure nullable parameters have default
	if formats == nil {
		formats = strfmt.Default
	}

	cli := new(DependencyTrackAPI)
	cli.Transport = transport
	cli.Bom = bom.New(transport, formats)
	cli.Component = component.New(transport, formats)
	cli.Finding = finding.New(transport, formats)
	cli.Project = project.New(transport, formats)
	cli.Vulnerability = vulnerability.New(transport, formats)
	return cli
}

// DefaultTransportConfig creates a TransportConfig with the
// default settings taken from the meta section of the spec file.
func DefaultTransportConfig() *TransportConfig {
	return &TransportConfig{
		Host:     DefaultHost,
		BasePath: DefaultBasePath,
		Schemes:  DefaultSchemes,
	}
}

// TransportConfig contains the transport related info,
// found in the meta section of the spec file.
type TransportConfig struct {
	Host     string
	BasePath string
	Schemes  []string
}

// WithHost overrides the default host,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithHost(host string) *TransportConfig {
	cfg.Host = host
	return cfg
}

// WithBasePath overrides the default basePath,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithBasePath(basePath string) *TransportConfig {
	cfg.BasePath = basePath
	return cfg
}

// WithSchemes overrides the default schemes,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithSchemes(schemes []string) *TransportConfig {
	cfg.Schemes = schemes
	return cfg
}

// DependencyTrackAPI is a client for dependency track API
type DependencyTrackAPI struct {
	Bom bom.ClientService

	Component component.ClientService

	Finding finding.ClientService

	Project project.ClientService

	Vulnerability vulnerability.ClientService

	Transport runtime.ClientTransport
}

// SetTransport changes the transport on the client and all its subresources
func (c *DependencyTrackAPI) SetTransport(transport runtime.ClientTransport) {
	c.Transport = transport
	c.Bom.SetTransport(transport)
	c.Component.SetTransport(transport)
	c.Finding.SetTransport(transport)
	c.Project.SetTransport(transport)
	c.Vulnerability.SetTransport(transport)
}
