// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"context"
	"net/http"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	"github.com/openclarity/kubeclarity/api/server/models"
)

// GetVulnerabilitiesHandlerFunc turns a function with the right signature into a get vulnerabilities handler
type GetVulnerabilitiesHandlerFunc func(GetVulnerabilitiesParams) middleware.Responder

// Handle executing the request and returning a response
func (fn GetVulnerabilitiesHandlerFunc) Handle(params GetVulnerabilitiesParams) middleware.Responder {
	return fn(params)
}

// GetVulnerabilitiesHandler interface for that can handle valid get vulnerabilities params
type GetVulnerabilitiesHandler interface {
	Handle(GetVulnerabilitiesParams) middleware.Responder
}

// NewGetVulnerabilities creates a new http.Handler for the get vulnerabilities operation
func NewGetVulnerabilities(ctx *middleware.Context, handler GetVulnerabilitiesHandler) *GetVulnerabilities {
	return &GetVulnerabilities{Context: ctx, Handler: handler}
}

/* GetVulnerabilities swagger:route GET /vulnerabilities getVulnerabilities

Get vulnerabilities

*/
type GetVulnerabilities struct {
	Context *middleware.Context
	Handler GetVulnerabilitiesHandler
}

func (o *GetVulnerabilities) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewGetVulnerabilitiesParams()
	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}

// GetVulnerabilitiesOKBody get vulnerabilities o k body
//
// swagger:model GetVulnerabilitiesOKBody
type GetVulnerabilitiesOKBody struct {

	// List of vulnerabilities in the given filters and page. List length must be lower or equal to pageSize
	Items []*models.Vulnerability `json:"items"`

	// Total vulnerabilities count under the given filters
	// Required: true
	Total *int64 `json:"total"`
}

// Validate validates this get vulnerabilities o k body
func (o *GetVulnerabilitiesOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateItems(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateTotal(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetVulnerabilitiesOKBody) validateItems(formats strfmt.Registry) error {
	if swag.IsZero(o.Items) { // not required
		return nil
	}

	for i := 0; i < len(o.Items); i++ {
		if swag.IsZero(o.Items[i]) { // not required
			continue
		}

		if o.Items[i] != nil {
			if err := o.Items[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("getVulnerabilitiesOK" + "." + "items" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (o *GetVulnerabilitiesOKBody) validateTotal(formats strfmt.Registry) error {

	if err := validate.Required("getVulnerabilitiesOK"+"."+"total", "body", o.Total); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this get vulnerabilities o k body based on the context it is used
func (o *GetVulnerabilitiesOKBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := o.contextValidateItems(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetVulnerabilitiesOKBody) contextValidateItems(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(o.Items); i++ {

		if o.Items[i] != nil {
			if err := o.Items[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("getVulnerabilitiesOK" + "." + "items" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetVulnerabilitiesOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetVulnerabilitiesOKBody) UnmarshalBinary(b []byte) error {
	var res GetVulnerabilitiesOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
